<template>
  <page
    class="flex-grow-1"
    id="user-data-page"
    v-if="user"
    :title="`Usuário ${user.code}`"
  >
    <v-divider />
    <v-subheader>Dados</v-subheader>
    <data-entry
      label="Email"
      :value="user.email"
    />
    <data-entry
      label="Roles"
      :value="user.roles"
    >
      <template slot-scope="value">
        <v-chip-group>
          <v-chip
            v-for="role in value.value"
            :key="role"
          >{{role}}</v-chip>
        </v-chip-group>
      </template>
    </data-entry>
  </page>
</template>

<script lang="ts">
import Vue from 'vue'

import Page from '@/components/Page.vue'
import DataEntry from '@/components/utils/DataEntry.vue'

import { DateTime } from 'luxon'

import userInfoQuery from '@/gql/UserQuery.gql'

export default Vue.extend({
  name: 'UsersPage',
  components: { Page, DataEntry },
  data: (): {
    user: any
  } => ({
    user: null
  }),
  computed: {
    id (): string {
      return this.$route.params.id
    }
  },
  apollo: {
    user: {
      query: userInfoQuery,
      variables (): { id: string } {
        return {
          id: this.id
        }
      },
      skip (): boolean {
        return !this.id
      }
    }
  },
  methods: {
    timeFromISO (time: string) {
      return DateTime.fromISO(time).toFormat('dd/MM/yyyy - TT')
    }
  }
})
</script>
